rm(list = ls()) 
library(ggplot2)
library(readxl)
library(corrplot)
library(ggcorrplot)
library(mediation)
library(foreign)
library(tableone)
library(table1)
library(compareGroups)
library(epiDisplay)
library(dplyr)
#数据读取
data_totalr<- read_excel("data_111.xlsx", sheet = "Sheet1")
#数据标识

names(data_totalr)[c(2:13)]<-c("Gender","SNAP","PCS","NCS","Anxiety_neurosis","Depressive_disorder"
                              ,"IA","AGE","PC","AP","PR","FR")
data_raw<-data_totalr
data_total<-data_totalr[,c(1,2,6:13,18,21:27)]
names(data_total)[c(11:18)]<-c("ADHD","S_BIS","C_BIS","P_BIS","BIS","DEPRESS","ANXIOUS","IAD")

#数据因子标识
data_total$NSSI<-factor(data_total$NSSI,levels = c(0,1),labels = c("Negative","Positive"))
data_total$Gender<-factor(data_total$Gender,levels = c(2,1),labels = c(" Female"," Male"))
data_total$AGE<-factor(data_total$AGE,levels = c(2,1),labels = c(" 14-16"," 11-13"))
data_total$PC<-factor(data_total$PC,levels = c(3,2,1),labels = c(" normal"," good"," weak"))
data_total$AP<-factor(data_total$AP,levels = c(4,3,2,1),labels = c(" excellent"," good"," average"," poor"))
data_total$PR<-factor(data_total$PR,levels = c(3,2,1),labels = c(" close"," average"," poor"))
data_total$FR<-factor(data_total$FR,levels = c(4,3,2,1),labels = c(" harmony",
                                                                   " quarrel conflict",
                                                                   " domestic violence",
                                                                   " separation/divorce"))
# data_total$ADHD<-factor(data_total$ADHD,levels = c(3,2,1,0),labels=c(" Hybrid",
#                                                                          " Hyperactivity",
#                                                                          " Attention Defects",
#                                                                          " Normal"))
# data_total$DEPRESS<-factor(data_total$DEPRESS,levels = c(1,0),labels = c("Positive",
#                                                                          "Negative"))
# data_total$ANXIOUS<-factor(data_total$ANXIOUS,levels = c(1,0),labels = c("Positive",
#                                                                          "Negative"))
# data_total$IAD<-factor(data_total$IAD,levels = c(1,0),labels = c("Positive",
#                                                                          "Negative"))

data_total$ADHD<-factor(data_total$ADHD,levels = c(0,1,2,3),labels=c(" Normal",
                                                                     " Attention Defects",
                                                                     " Hyperactivity",
                                                                    " Hybrid" ))
data_total$DEPRESS<-factor(data_total$DEPRESS,levels = c(0,1),labels = c(" Negative",
                                                                         " Positive"))
data_total$ANXIOUS<-factor(data_total$ANXIOUS,levels = c(0,1),labels = c(" Negative",
                                                                         " Positive"))
data_total$IAD<-factor(data_total$IAD,levels = c(0,1),labels = c(" Negative",
                                                                 " Positive"))
# names(data_total)[c(8:12)]<-c("ADHD","SBIS","CBIS","PBIS","BIS")
names(data_total)[c(11:15)]<-c("ADHD","S_BIS","C_BIS","P_BIS","BIS")
data_total[,19]<-data_totalr[,3]
data_total[,20]<-data_totalr[,16]
data_total[,21]<-data_totalr[,17]
names(data_total)[c(19:21)]<-c("ADHD total","ADHD Anttention Defects","ADHD Hyperactivity")
#单因素分析
data_total<-as.data.frame(data_total)
des(data_total)
table1<-tableStack(vars=3:21,by="none",dataFrame=data_total,name.test = FALSE)
table2<-tableStack(vars=3:21,by=NSSI,dataFrame=data_total,name.test = FALSE,means=TRUE)
table3<-tableStack(vars=3:21,by=Gender,dataFrame=data_total,name.test = FALSE)
write.csv(table1,file="table1.csv")
write.csv(table2,file="table2.csv")
write.csv(table3,file="table3.csv")
#逻辑回归
md<- glm(NSSI~Gender+ADHD+AGE+PC+AP+PR+FR+S_BIS+C_BIS+P_BIS+Anxiety_neurosis+Depressive_disorder+IA,data=data_total,
         family = "binomial")
md<- glm(NSSI~Gender+ADHD+AGE+PC+AP+PR+FR+S_BIS+C_BIS+P_BIS+DEPRESS+ANXIOUS+IAD,data=data_total,
         family = "binomial")
summary(md)
#逐步逻辑回归
out.fit.NSSI<-md
out.fit.NSSI<- step(md,direction="both")
summary(out.fit.NSSI)



md<- glm(NSSI~Gender+SNAP+PCS+NCS+EMO+IAT+AGE+PC+AP+PR+FR,data=data_total,
         family = "binomial")
summary(md)
#逐步逻辑回归
out.fit.NSSI<- step(md,direction="both")
summary(out.fit.NSSI)

tabletext<-data.frame(
  Variables =c ("Female","SNAP","PCS","NCS","EMO","IAT","Normal","Good"),
  mean=exp(coef(out.fit.NSSI))[-1],
  lower= exp(confint(out.fit.NSSI))[-1,1],
  upper= exp(confint(out.fit.NSSI))[-1,2],
)

exp(coef(out.fit.NSSI))
exp(confint(out.fit.NSSI))

fit.result<-summary(out.fit.NSSI)
df1<-fit.result$coefficients
df2<-exp(confint(out.fit.NSSI))
# df2<-confint(out.fit.NSSI)
df3<-cbind(df1,df2)
df4<-data.frame(df3[-1,c(1,4,5,6)])
df4$Var<-rownames(df4)
colnames(df4)<-c("OR","Pvalue","OR_1","OR_2","Variables")
df4$OR<-exp(coef(out.fit.NSSI))[-1]
df5<-df4[,c(5,1,2,3,4)]
df5$OR_mean<-df5$OR
df5$OR<-paste0(round(df5$OR,2),
               "(",
               round(df5$OR_1,2),
               "~",
               round(df5$OR_2,2),
               ")")
df5$Pvalue<-round(df5$Pvalue,3)
df5$''<- paste(rep("",8),collapse = " ")
df6<-cbind(df1[-1,],df5)
df6[,1:4]<- round(df6[,1:4],2)
names(df6)[11]<-c("")
# write.csv(df6,file="fit.csv")


library(forestploter)

tm<-forest_theme(base_size = 20,
                 # vertline_lwd = 2,
                 ci_pch = 1,
                 ci_col = ("#4575b4"),
                 ci_lty = 1,
                 ci_lwd = 2.5,
                 ci_Theight = 0.35,
                 
                 refline_lwd = 2,
                 refline_lty = "dashed",
                 refline_col = "grey20",
                 
                 footnote_cex = 1,
)
                 


p<- forest(data=df6[,c(5,1:3,7,11,6)],
           lower=df6$OR_1,
           upper=df6$OR_2,
           est=df6$OR_mean,
           ci_column = 6,
          
           sizes = 0.5,
           # is_summary = c(rep(FALSE,nrow(df6)-1),TRUE),
           ref_line = 1,
           # ticks_at = c(0,1,2,3,4),
           # xlim = c(0,4),
           ticks_at = c(0,1,5,10),
           xlim = c(0,10),
           arrow_lab = c("reduce","increase"),
           footnote = "AIC=824.6",
           # footnote = "AIC=807.51",
           theme=tm
)
print(p)


df<- read.csv("fit1.csv",header= T)
names(df)[11]<-c("")
df$``<-paste(rep(" ",12),collapse = " ")
df[is.na(df)] = " "

tm <- forest_theme(base_size = 14,# 激大小
                   # 可信区间点的形状，线垄、颇色、宽度
                   ci_pch = 16,
                   ci_col = "#4575b4", # #762a83
                   ci_lty = 1,
                   ci_lwd = 2,
                   ci_Theight = 0.2,# 可信区间两加知监线
                   #参考线发度、形状、颇色
                   refline_lwd = 1.5,
                   refline_lty = "dashed",
                   refline_col = "grey20",
                   # 汇总莲形的美充色和边框色
                   summary_fill = "#4575b4",
                   summary_col = "#4575b4",
                   #御注大小、字体、颇色
                   footnote_cex = 0.8,
                   footnote_fontface = "italic",
                   footnote_col = "grey30",
                   # 自定义背素色、前案色。fontface:1规，2超体，3斜体，4超斜体
                   core = list(bg_params = list(fill = c("#FFFFFF","#E6E6E6"), col=NA),
                               fg_params = list(
                                 fontface=c(2,rep(c(2,3,3),3),2,3,3,3,rep(c(2,3,3),4))),
                               # 标餐行颇色、字体
                               colhead = list(fg_params = list(col="navyblue", fontface=2)))
)

p <- forest(
  data = df[,c(1,2,3,4,7,11,6)],
  lower = df$OR_1,
  upper = df$OR_2,
  est = df$OR_mean,
  ci_column = 6,
  sizes = 0.5,
  # is_summary = c(TRUE,rep(FALSE,nrow(df)-1)),# 后一测是汇行
  ref_line = 1,
  ticks_at = c(0,1,2,3,4),
  xlim = c(0,4),
  arrow_lab = c("reduce","increase"),
  footnote = "Add other information here.\nAnd free to change to the next line.", # 在下网
  theme = tm
)

print(p)


#相关性分析

# data_select<-data_raw[,c(1,2,3,4,5,6,8,10)]
data_select<-data_raw[,c(1,2,6,7,8,16,17,3)]
names(data_select)[c(3:8)]<-c("Anxiety","Depression","IAD","ADHD_AD","ADHD_HI","ADHD_C" )
data_select_male<-data_select[data_select[,2]==1,c(1,3,4,5,6,7,8)]
data_select_female<-data_select[data_select[,2]==2,c(1,3,4,5,6,7,8)]

cormtdata <- round(cor(data_select_male), 3) #round()函数自定义小数点后位数  这里存了相关系数
pmtdata <- cor_pmat(data_select_male)   # 这里存了p-value

cormtdata <- round(cor(data_select_female), 3) #round()函数自定义小数点后位数  这里存了相关系数
pmtdata <- cor_pmat(data_select_female)   # 这里存了p-value

cormtdata <- round(cor(data_select), 3) #round()函数自定义小数点后位数  这里存了相关系数
pmtdata <- cor_pmat(data_select)   # 这里存了p-value

write.csv(data_select_female,"data_select_female.csv")
write.csv(data_select_male,"data_select_male.csv")

#中介效应分析
# data_select<-data_total[,c(1,2,3,4,5,6,8,10)]
data_select<-data_raw[,c(1,2,6,7,16,17,3)]
names(data_select)[c(5,6)]<-c("SNAP_Attention Defects",
                              "SNAP_hyperactivity")





out.fit.NSSI<- glm(NSSI~SNAP_Attention+SNAP_hyperactivity+EMO+DSRSC,data=data_select,
                   family = "binomial")
out.fit.NSSI<- glm(NSSI~SNAP+PCS,data=data_select,
                   family = "binomial")

med.fit.IAT <- lm(IAT~ Gender+SNAP+PC, data = data_select)
med.fit.EMO <- lm(EMO~ SNAP, data = data_select)
med.fit.PCS <- lm(PCS~ SNAP, data = data_select)
med.fit.NCS <- lm(NCS~ SNAP, data = data_select)
med.out <- mediate(med.fit.EMO, out.fit.NSSI, treat = "SNAP", mediator = "EMO",
                   robustSE = TRUE, sims = 100)###treat填自变量，mediator填中介变量
med.out <- mediate(med.fit.IAT, out.fit.NSSI, treat = "SNAP", mediator = "IAT",
                   robustSE = TRUE, sims = 100)###treat填自变量，mediator填中介变量
med.out <- mediate(med.fit.PCS, out.fit.NSSI, treat = "SNAP", mediator = "PCS",
                   robustSE = TRUE, sims = 100)###treat填自变量，mediator填中介变量
med.out <- mediate(med.fit.NCS, out.fit.NSSI, treat = "SNAP", mediator = "NCS",
                   robustSE = TRUE, sims = 100)###treat填自变量，mediator填中介变量
# med.fit.IAT <- lm(IAT~ Gender+SNAP+PCS+NCS+EMO+PC, data = data_select)
# med.fit.SNAP <- lm(SNAP~ Gender+EMO+PCS+NCS+PC+IAT, data = data_select)
# med.out <- mediate(med.fit.SNAP, out.fit.NSSI, treat = "EMO", mediator = "SNAP",
#                    robustSE = TRUE, sims = 100)###treat填自变量，mediator填中介变量
# med.out <- mediate(med.fit.IAT, out.fit.NSSI, treat = "EMO", mediator = "IAT",
#                    robustSE = TRUE, sims = 100)###treat填自变量，mediator填中介变量



out.fit.NSSI<- glm(NSSI~SNAP_Attention+EMO,data=data_select,
                   family = "binomial")
med.fit.EMO <- lm(EMO~ SNAP_Attention, data = data_select)
med.out <- mediate(med.fit.EMO, out.fit.NSSI, treat = "SNAP_Attention", mediator = "EMO",
                   robustSE = TRUE, sims = 100)###treat填自变量，mediator填中介变量


summary(med.out)
plot(med.out)

write.csv(data_total,"data_total.csv")


table1(~ . | NSSI*Gender, data =data_total, topclass="Rtable1-zebra")
restab <- descrTable(NSSI ~ ., data = data_total)
restab
export2word(restab, file='table1.docx') # 直接是三线表的格式
